// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* \li ̧			: main.c
* \li ߲		: IAR EWAAVR 3.20a
* \li xҰ		: avr@atmel.com
*
* \li x޲	: UART܂USARTSĂAVR
*
* \li pLq		: AVR318 - Dallas 1-Wire(R)呕u
*
* \li 			: 1-Wire(R)K̊荞݋쓮UARTgp@̗
*
*                         $Revision: 1.7 $
*                         $Date: Thursday, August 19, 2004 14:27:16 UTC $
****************************************************************************/

#include <ioavr.h>
#include <inavr.h>

#include "OWIIntFunctions.h"
#include "OWIInterruptDriven.h"
#include "..\common_files\OWIcrc.h"

void OWI_StateMachine();

// ޗ݂̂Ŏgp`
#define OWI_STATE_IDLE					0		//!< Ԕԍ0: 
#define OWI_STATE_DETECT_PRESENCE1		1		//!< Ԕԍ1: ݌o1
#define OWI_STATE_WAIT_FOR_CONVERSION1	2		//!< Ԕԍ2: ϊҋ@1
#define OWI_STATE_WAIT_FOR_CONVERSION2	3		//!< Ԕԍ3: ϊҋ@2
#define OWI_STATE_DETECT_PRESENCE2		4		//!< Ԕԍ4: ݌o2
#define OWI_STATE_READ_SCRATCHPAD		5		//!< Ԕԍ5: GLǂݍ
#define OWI_STATE_CHECK_CRC				6		//!< Ԕԍ6: CRC

#define FALSE       0
#define TRUE        1

#define DS1820_START_CONVERSION			0x44	//!< DS1820ϊJn
#define DS1820_READ_SCRATCHPAD			0xBE	//!< DS1820GLǂݍݖ

extern OWIflags OWIStatus;
extern unsigned char *OWIDataBuffer;

signed int temperature;

/*! \brief 荞݋쓮ײޗpޗ
 *
 * ̺ޗ1-Wire޽ɐڑꂽDS1820xm킪Ɖ肵܂Bx
 * m͌pI߰ݸނAxǂݍ݂߰Bɏo͂܂B
 */
void main(void)
{

  OWI_Init();						// 1-Wireײޏ
  __enable_interrupt();				// S̊荞݋
  DDRB = 0xFF;						// S߰Bo͐ݒ(STK500JLEDޯޒlo͂邱Ƃł܂B)

  for(;;)
  {
	if (!OWIStatus.busy)			// 1-Wire(R)޽ZłȂ΁A
	{
	  OWI_StateMachine();			// Lԋ@\s
	}
	// 1-Wire(R)޽Z̊ԁẢsĂB
	PORTB = ~(temperature >> 1);	// 擾xLED\
  }
}

/*! \brief 1-Wire޽̒ʐM𐧌䂷ԋ@\
 *
 * ̊֐1-WireײނZłȂmainĂ΂܂Bԋ@\DS1820
 * xm킩牷xǂ݁ACRCASĂOKȂAtemperatureS̕
 * ɒu܂B
 */
void OWI_StateMachine()
{
  static unsigned char state = OWI_STATE_IDLE;
  static unsigned char buf[9];
  unsigned char i;
  unsigned char crc;

  if (OWIStatus.error)							// ُLŁA
  {
	state = OWI_STATE_IDLE;						// ԔԍُԂɕύX
	OWIStatus.allFlags = FALSE;					// S׸މ
  }

  switch (state)								// Ԉˑs
  {
	case OWI_STATE_IDLE:						// ُ
	{
	  OWI_DetectPresence();						// 1-WireؾĐMo,ݐMo
	  state = OWI_STATE_DETECT_PRESENCE1;		// Ԕԍ𑶍݌o1ԂɕύX
	  break;
	}

	case OWI_STATE_DETECT_PRESENCE1:			// ݌o1
	{
	  if(OWIStatus.presenceDetected == FALSE)	// ݂ȂŁA
	  {
		state = OWI_STATE_IDLE;					// ԔԍُԂɕύX
	  }
	  else										// ݗLŁA
	  {
		buf[0] = OWI_ROM_SKIP;					// ޯ̧SKIPߊi[
		buf[1] = DS1820_START_CONVERSION;		// ޯ̧DS1820ϊJnߊi[
		OWI_TransmitData(buf, 16);				// DS1820֕ϊJnߑM
		state = OWI_STATE_WAIT_FOR_CONVERSION1;	// Ԕԍϊҋ@1ԂɕύX
	  }
	  break;
	}

	case OWI_STATE_WAIT_FOR_CONVERSION1:		// ϊҋ@1
	{
	  OWI_ReceiveData(buf, 8);					// DS1820ϊp1-Wireްǂݍ
	  state = OWI_STATE_WAIT_FOR_CONVERSION2;	// Ԕԍϊҋ@2ԂɕύX
	  break;
	}
    
	case OWI_STATE_WAIT_FOR_CONVERSION2:		// ϊҋ@2
	{
	  if (buf[0] == 0x00)						// ϊ(Ml=0)ŁA
	  {
		state = OWI_STATE_WAIT_FOR_CONVERSION1;	// Ԕԍϊҋ@1ԂɕύX(Ď擾)
	  }
	  else										// ϊ(Ml>0)ŁA
	  {
		OWI_DetectPresence();					// 1-WireؾĐMo,ݐMo(DS1820ؾėp)
		state = OWI_STATE_DETECT_PRESENCE2;		// Ԕԍ𑶍݌o2ԂɕύX
	  }
	  break;
	}

	case OWI_STATE_DETECT_PRESENCE2:			// ݌o2
	{
	  if(OWIStatus.presenceDetected == FALSE)	// ݂ȂŁA
	  {
		state = OWI_STATE_IDLE;					// ԔԍُԂɕύX
	  }
	  else										// ݗLŁA
	  {
		buf[0] = OWI_ROM_SKIP;					// ޯ̧SKIPߊi[
		buf[1] = DS1820_READ_SCRATCHPAD;		// ޯ̧DS1820GLǂݍݖߊi[
		OWI_TransmitData(buf, 16);				// DS1820֎GLǂݍݖߑM
		state = OWI_STATE_READ_SCRATCHPAD;		// ԔԍGLǂݍݏԂɕύX
	  }
	  break;
	}

	case OWI_STATE_READ_SCRATCHPAD:				// GLǂݍݏ
	{
	  OWI_ReceiveData(buf, 9 * 8);				// DS1820̎GL9޲ēǂݍ
	  state = OWI_STATE_CHECK_CRC;				// ԔԍCRCԂɕύX
	  break;
	}

	case OWI_STATE_CHECK_CRC:					// CRC
	{
	  crc = 0;									// CRCl擾
	  for(i = 0; i < 8; i++)					// 擪8޲ĂCRC8vZ
	  {
		crc =  OWI_ComputeCRC8(buf[i], crc);	// Ή޲CRCvZ
	  }
	  if (crc == buf[8])						// MCRCƈvŁA
	  {
		temperature = buf[0] | (buf[1] << 8);	// 16ޯĂł̉xl擾
		state = OWI_STATE_IDLE;					// ԔԍُԂɕύX
	  }
	  else
	  {
		OWI_DetectPresence();					// 1-WireؾĐMo,ݐMo(DS1820ؾėp)
		state = OWI_STATE_DETECT_PRESENCE2;		// Ԕԍ𑶍݌o2ԂɕύX
	  }
	  break;
	}
  }
}

